unit text3dform;

interface

uses
  {$IFNDEF FPC}Windows, {$ELSE}LResources, {$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, dx_scene, dx_controls, dx_textbox, dx_utils, dx_objects,
  ExtCtrls,
  dx_vgcore, dx_vglayer;

type

  { TForm7 }

  TForm7 = class(TForm)
    dxScene1: TdxScene;
    Root1: TdxVisualObject;
    FontDialog1: TFontDialog;
    camerax: TdxDummy;
    Camera1: TdxCamera;
    Text3D1: TdxText3D;
    Light1: TdxLight;
    BitmapObject1: TdxBitmapObject;
    Timer1: TTimer;
    Layer2D: TdxGUIObjectLayer;
    Root2: TvxLayout;
    HudWindow1: TvxHudWindow;
    HudTextBox1: TvxHudTextBox;
    HudButton1: TvxHudButton;
    HudButton2: TvxHudButton;
    Label1: TvxLabel;
    HudTrackBar1: TvxHudTrackBar;
    Label2: TvxLabel;
    CheckBox1: TvxCheckBox;
    cameraz: TdxDummy;
    Label3: TvxLabel;
    HudTrackBar2: TvxHudTrackBar;
    procedure Button1Click(Sender: TObject);
    procedure dxScene1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure dxScene1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure TextBox1Change(Sender: TObject);
    procedure dxScene1MouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure HudWindow1CloseClick(Sender: TObject);
    procedure HudTrackBar1Change(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);
    procedure HudTrackBar2Change(Sender: TObject);
  private
    { Private declarations }
    Down: TdxPoint;
  public
    { Public declarations }
  end;

var
  Form7: TForm7;

implementation

uses dx_dsgn_material;

{$ifndef FPC}
{$R *.dfm}
{$endif}

procedure TForm7.Button1Click(Sender: TObject);
begin
  FontDialog1.Font.Name := Text3D1.Font.Family;
  if Text3D1.Font.Style in [dxFontBold, dxFontBoldItalic] then
    FontDialog1.Font.Style := FontDialog1.Font.Style + [fsBold];
  if Text3D1.Font.Style in [dxFontItalic, dxFontBoldItalic] then
    FontDialog1.Font.Style := FontDialog1.Font.Style + [fsItalic];
  if FontDialog1.Execute then
  begin
    Text3D1.Font.Family := FontDialog1.Font.Name;
    if (fsBold in FontDialog1.Font.Style) and (fsItalic in FontDialog1.Font.Style) then
      Text3D1.Font.Style := dxFontBoldItalic;
    if (fsBold in FontDialog1.Font.Style) and not (fsItalic in FontDialog1.Font.Style) then
      Text3D1.Font.Style := dxFontBold;
    if not (fsBold in FontDialog1.Font.Style) and (fsItalic in FontDialog1.Font.Style) then
      Text3D1.Font.Style := dxFontItalic;
    if not (fsBold in FontDialog1.Font.Style) and not (fsItalic in FontDialog1.Font.Style) then
      Text3D1.Font.Style := dxFontRegular;
  end;
end;

procedure TForm7.dxScene1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssRight in Shift then
  begin
    cameraz.RotateAngle.Z := cameraz.RotateAngle.Z + (X - Down.X);
    camerax.RotateAngle.X := camerax.RotateAngle.X + (Y - Down.Y);
    Down := dxPoint(X, Y, 0);
  end;
end;

procedure TForm7.dxScene1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Down := dxPoint(X, Y, 0);
end;

procedure TForm7.FormCreate(Sender: TObject);
var
  R: TvxRectangle;
begin
  { }
  exit;
  R := TvxRectangle.Create(Self);
  R.Parent := Root2;
  R.Align := vaClient;
  R.StrokeThickness := 3;
  R.fill.Style := vgBrushGradient;
  R.xRadius := 8;
  R.yRadius := 8;
end;

procedure TForm7.TextBox1Change(Sender: TObject);
begin
  Text3D1.Text := HudTextBox1.Text;
end;

procedure TForm7.dxScene1MouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
  Camera1.Position.Vector := dxVectorAdd(Camera1.Position.Vector, dxVectorScale(dxVector(0, 1, 0),
    (WheelDelta/30) * 0.3));
end;

procedure TForm7.Button2Click(Sender: TObject);
begin
  {}
  frmMaterialDesign := TfrmMaterialDesign.Create(Application);
  frmMaterialDesign.Material := Text3D1.Material;
  frmMaterialDesign.ParentScene := dxScene1;
  frmMaterialDesign.ShowModal;
  frmMaterialDesign.Free;
end;

procedure TForm7.Timer1Timer(Sender: TObject);
begin
  Caption := FloattoStr(dxScene1.fps);
end;

procedure TForm7.HudWindow1CloseClick(Sender: TObject);
begin
  case random(2) of
    1: Layer2D.AnimateFloat('RotateAngle.Y', Layer2D.RotateAngle.Y + 360, 1);
  else
    Layer2D.AnimateFloat('RotateAngle.X', Layer2D.RotateAngle.X + 360, 1);
  end;
end;

procedure TForm7.HudTrackBar1Change(Sender: TObject);
begin
  Text3D1.Depth := HudTrackBar1.Value;
end;

procedure TForm7.CheckBox1Change(Sender: TObject);
begin
  if CheckBox1.IsChecked then
    Text3D1.Material.FillMode := dxWireframe
  else
    Text3D1.Material.FillMode := dxSolid;
end;

procedure TForm7.HudTrackBar2Change(Sender: TObject);
begin
  Text3D1.Flatness := HudTrackBar2.Value;
end;

end.
